# libdict

libdict is a C library that provides the following data structures with efficient insert, lookup, and delete routines:
* [height-balanced (AVL) tree](http://en.wikipedia.org/wiki/AVL_tree)
* [red-black tree](http://en.wikipedia.org/wiki/Red-black_tree)
* [splay tree](http://en.wikipedia.org/wiki/Splay_tree)
* weight-balanced tree
* [path-reduction tree](https://cs.uwaterloo.ca/research/tr/1982/CS-82-07.pdf)
* [treap](http://en.wikipedia.org/wiki/Treap)
* [hashtable, using separate chaining](http://en.wikipedia.org/wiki/Hashtable#Separate_chaining)
* [hashtable, using open addressing with linear probing](http://en.wikipedia.org/wiki/Hashtable#Open_addressing)

A generic object-oriented interface is provided, but is not required.

## License

libdict is released under the simplified BSD [license](https://github.com/fmela/libdict/blob/master/LICENSE).
